/*
 * Created on 20.04.2004
 *
*/
package org.dronus.dope;

import java.io.*;
import java.util.*;


public class FilePool {

	HashMap map;
	HashMap dataTypes=new HashMap();
	HashMap fileTypes=new HashMap();
	
	public FilePool() {
		reset();
		File typesFile=new File("datatypes.txt");
		try {
			BufferedReader  r=new BufferedReader(new InputStreamReader (new FileInputStream(typesFile)));
			String line;
			while ((line=r.readLine())!=null){
				String[] data=line.split(" ");
				List l=new LinkedList();
				dataTypes.put(data[0],l); 
				for (int i=1; i<data.length; i++)	{
					l.add(data[i]);
					fileTypes.put(data[i],data[0]);
				}
					 					
			}			
			System.out.println("FilePool: "+dataTypes.size()+" datatypes loaded.");
		} catch (IOException e) {
			e.printStackTrace();
		}		
	}

	public void reset()	{map=new HashMap (100,.5f);};
	public Set getTags(File f){return setForTagString(f.getName());}
	public Set setForTagString(String tags){
		Set s=new HashSet();
		StringTokenizer t=new StringTokenizer(tags.toLowerCase(),".");
		while(t.hasMoreElements())
			s.add(t.nextToken());
		return s;
	}
	public void addFile(File f){
		Set s=getTags(f);
		Set l;
		if ((l=(Set)map.get(s))==null) 
			map.put(s,l=new HashSet());
		l.add(f);		
	}
	
	public void addDir(String dir){addDir(new File(dir));}
	public void addDir(File dir){
		File[] files=dir.listFiles();
		
		if (files!=null) for (int i=0; i<files.length;i++)
			if (files[i].isDirectory()) addDir(files[i]); 
			else addFile(files[i]);
		else System.out.println("FilePool: dir "+dir.getPath()+ " not found.");				
	}
	public Set getFilesExact(Set s){
		return (Set)map.get(s);
	}
	public Set getFiles(String tags){return getFiles(setForTagString(tags));}
	public Set getFiles(Set tags){
		Set files=new HashSet();
		Iterator it=map.entrySet().iterator();
		while (it.hasNext()){
			Map.Entry e=(Map.Entry)it.next();
			if (((Set)e.getKey()).containsAll(tags))  files.addAll((Set)e.getValue());
		}
		return files; 
	}
	public void printFiles(String tags){
		Set s=getFiles(setForTagString(tags));
		Iterator it=s.iterator();		
		while (it.hasNext())
			System.out.println(it.next());
		System.out.println("---");
	}
	
	public static void main(String[] args) {
		FilePool p=new FilePool();
		p.addDir(new File("e://eigene dateien/eigene bilder/photos"));
		p.printFiles("tui");
	}
	static FilePool defaultpool;
	public static FilePool getDefaultPool(){
		if(defaultpool==null) defaultpool=new FilePool();
		return defaultpool;
	};
	public Set getBySomething(String something, String type){
		Set s=new HashSet(); 
		String tags=something.replaceAll("[\",\\- ]","");
		if (dataTypes.get(type)!=null){
		Iterator tit=((List)dataTypes.get(type)).iterator();						
			while (tit.hasNext()) //by datatype
				s.addAll(getFiles(tags+"."+(String)tit.next()));
		} else s.addAll(getFiles(tags));
		Iterator it=s.iterator();
		while (it.hasNext()) System.out.println(it.next()); 
		return s;
	}
	
	public void invokeBySomething(String something, String type){
		String clean=something.replaceAll("[\",\\- ]","");
		if (!invokeByTagsAndType(clean,type))
			invokeByTags(clean);
	}
	public boolean invokeByTagsAndType(String tags, String type){
		if (!dataTypes.containsKey(type)) return false;
		Iterator tit=((List)dataTypes.get(type)).iterator();						
		while (tit.hasNext()){
			Iterator it=getFiles(tags+"."+(String)tit.next()).iterator();
			if (it.hasNext()) {
				File f=(File)it.next();
				invoke(f);
				return true;
			}
		}			
		return false;
	}
	
	public boolean invokeByTags(String tags){
		Iterator it=getFiles(tags).iterator();
		if (!it.hasNext()) return false;
		File f=(File)it.next();
		if (f==null) return false;
		invoke(f);
		return true;
	}
	public void invoke(File file){
		System.out.println("FilePool:invoke "+file.getAbsolutePath());
		try {
			Runtime.getRuntime().exec("cmd.exe /C \""+file.getAbsolutePath()+"\"" );
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * @param string
	 * @return
	 */
	public String getDataType(String string) {
		return (String)fileTypes.get(string);
	}
}
