package org.dronus.exploder;
import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.image.*;
import java.util.*;
import javax.imageio.*;
import javax.imageio.stream.*;
import java.io.*;

public class ImageLoader{
	static HashMap imgs=new HashMap();
	static final String basedir="grafik/", thumbsdir="thumbs/"; 
	
	public static BufferedImage getImg(String s) {
		ImageIO.setUseCache(false);
		if (s==null) return null;
		BufferedImage img=null;		
		if (!imgs.containsKey(s)){
			String filename=s.replace('\\','/');
			try{	
				if (s.indexOf('.')<0){
					filename=basedir+filename.replace('','a').replace('','o').replace('','u').replace('','s')+".png"; 					
					img=ImageIO.read(new MemoryCacheImageInputStream(ImageLoader.class.getClassLoader().getResource(filename).openStream()));			
				}else
					img=ImageIO.read(new MemoryCacheImageInputStream(new FileInputStream(filename)));			
			}
			catch (Exception e) {
				System.out.println("ImageLoader: couldnt read "+filename);
			}
			imgs.put(s,img);		
		}else 
			img =(BufferedImage)imgs.get(s);
		return img;
	}
	public static BufferedImage getThumbnail(String s){
		String filename=thumbsdir+new File(s).getName();
		BufferedImage img=ImageLoader.getImg(filename);
		if (img==null){
			Image _img=ImageLoader.getImg(s);
			imgs.remove(s); 						
			img=makeScaled(_img);
			try {
				
				ImageIO.write(img,"jpg",new File(filename));
				System.out.println("ImageLoader: Thumb generated:"+filename);
			} catch (IOException e) {
				System.out.println("ImageLoader: Thumb could not be written.");
			}
			_img.flush();_img=null; //			
			System.gc();	
		}			
		return img;
	}
	public static BufferedImage makeScaled(Image _img){		
		int w= _img.getWidth(null);
		if (w==0) {
			System.out.println("ImageLoader: no thumb possible - zero width");
			return null;			
		} 
		BufferedImage im = new BufferedImage(64,64,BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D g=im.createGraphics();
		g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
		AffineTransform rot=new AffineTransform();
		double scale=64/(double)w;
		double h=_img.getHeight(null)*scale;
		//rot.translate(w/2*(1-scale),h/2*(1-scale));
		rot.scale(scale,scale);
		g.setTransform(rot);			
		g.drawImage(_img,32,(int)h/2,null);
		
		_img=null;
		return im;
	}
}
