
package org.dronus.graph.gui;

import  java.util.Vector;

/** TGLensSet:  A collection of lenses, where each lens is a function that
  *              warps 2D space.
  *
  * @author   Alexander Shapiro
  * @version  1.21  $Id: TGLensSet.java,v 1.15 2002/04/01 05:51:55 x_ander Exp $
  */
public class LensSet extends AbstractLens{

    Vector lenses=new Vector();

    public void addLens( AbstractLens l ) {
        //lenses.add(0,l);        
		lenses.add(l);
    }

    public void applyLens( Point2D p ) {
        if (lenses.isEmpty()) return;
        //else
        for (int i=0; i<lenses.size(); i++) {
            ((AbstractLens)lenses.elementAt(i)).applyLens(p);
        }
    }

    public void undoLens( Point2D p ) {
        if (lenses.isEmpty()) return;
        //else
        for (int i=lenses.size()-1; i>=0; i--) {
            ((AbstractLens) lenses.elementAt(i)).undoLens(p);
        }
    }
  
    /** Convert draw position to real position. */
    public Point2D convRealToDraw( double x, double y ) {
        Point2D newp = new Point2D(x,y);
        applyLens(newp);
        return newp;
    }

    /** Convert real position to draw position. */
    public Point2D convDrawToReal(double x, double y) {
        Point2D newp = new Point2D(x, y);
        undoLens(newp);
        return newp;
    }

} // end com.touchgraph.graphlayout.TGLensSet
