/*
 * Created on 26.03.2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.dronus.graph.gui;

import java.awt.*;
import java.awt.font.*;
import java.io.*;
import java.text.AttributedString;


public class TextNodeRenderer extends NodeRenderer {
	
	String text; 
	
	public TextNodeRenderer(LayoutableNode _n, File f) {
		super(_n);
		loadText(f);		
	}
	public void paint(Graphics g, boolean selected, boolean print) {
		//super.paintNodeBody(g, selected, print);
		if (text!=null) drawText(g);
	}
	public void drawText(Graphics g){
			Graphics2D g2d = (Graphics2D)g;
			FontRenderContext frc = g2d.getFontRenderContext();
			float x=(float)n.drawx,y=(float)n.drawy+32;
			LineBreakMeasurer measurer = new LineBreakMeasurer((new AttributedString(text)).getIterator(), frc);
			float wrappingWidth = 150;
			TextLayout layout;
			while ((layout = measurer.nextLayout(wrappingWidth))!=null) {
				 y += (layout.getAscent());
				layout.draw(g2d, x, y);
				 y += layout.getDescent() + layout.getLeading();
			}
		}

	public void loadText(File f){
		text="";
		try {
			BufferedReader r=new BufferedReader(new InputStreamReader(new FileInputStream(f)));
			String line;
			while((line=r.readLine())!=null)
				text+=(line+"\n");
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (text.equals("")) text=null;
	}

	 /* 
	 * 
	 * 
	 public void extendNodePopup(PopupMenu m, final MutaGraphPanel p){
			final LayoutableNode thisnode=n;
			MenuItem menuItem;		
			if (n.text==null){
				menuItem = new MenuItem("Text laden");
				menuItem.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {                    
						p.loadNodeText(thisnode);
						p.repaint();
					}		
				});
			}else{ 
				menuItem = new MenuItem("Text verbergen");
				menuItem.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {                    
						thisnode.text=null;
						p.repaint();
					}		
				});
			}
			m.add(menuItem);	
		 }*/ 
}
