
package org.dronus.graph.gui.interact;

import org.dronus.graph.gui.*;

import java.awt.*;
import  java.awt.event.*;

public class GraphEditUI extends GraphNavigateUI{
	DragAddUI dragAddUI;
    
    public GraphEditUI( MutaGUIPanel glPanel ) {		
		super(glPanel);
       	ml = new GLEditMouseListener();
       	dragAddUI = new DragAddUI(tgPanel);
        extendNodePopup();
        extendEdgePopup();
    }

 	class GLEditMouseListener extends GLNavigateMouseListener{
		public synchronized void mousePressed(MouseEvent e) {
			super.mousePressed(e);
			if ((e.getModifiers() & MouseEvent.BUTTON1_MASK)!=0)
					if((e.getModifiers() & MouseEvent.CTRL_MASK)!=0)
						dragAddUI.activate(e);            	                             			
		}
	}

    private void extendNodePopup() {
        MenuItem menuItem;
      
		menuItem = new MenuItem("Knoteneigenschaften...");
		ActionListener editAction = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(popupNode!=null) {
					tgPanel.changeNode(popupNode);
				}
			}
		};		
		menuItem.addActionListener(editAction);
		nodePopup.add(menuItem);
				
		menuItem = new MenuItem("Knoten exterminieren");
		ActionListener eraseAction = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(popupNode!=null) tgPanel.eraseNode(popupNode);
			}
		};		
		menuItem.addActionListener(eraseAction);
		nodePopup.add(menuItem);
    }

	private void extendEdgePopup() {
		MenuItem menuItem;
		menuItem = new MenuItem("Kante exterminieren");
		ActionListener deleteEdgeAction = new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if(popupEdge!=null)  tgPanel.deleteEdge(popupEdge);
				}
			};
		menuItem.addActionListener(deleteEdgeAction);
		edgePopup.add(menuItem);
	}
} 
