

package org.dronus.graph.gui.interact;

import org.dronus.graph.gui.*;

import java.awt.Scrollbar;
import  java.awt.event.*;

public class LocalityScroll  {

    private Scrollbar localitySB;

    private GraphPanel tgPanel;

    public LocalityScroll(GraphPanel tgp) {
        tgPanel=tgp;
        localitySB = new Scrollbar(Scrollbar.HORIZONTAL, 7, 1, 0, 7);
        localitySB.setBlockIncrement(1);
        localitySB.setUnitIncrement(1);
        localitySB.addAdjustmentListener(new localityAdjustmentListener());
    }

    public Scrollbar getLocalitySB() {
        return localitySB;
    }

    public int getLocalityRadius() {
        int locVal = localitySB.getValue();
        if(locVal>=6) return LocalityUtils.INFINITE_LOCALITY_RADIUS;
        else return locVal;
    }

    /*public void setLocalityRadius(int radius) {
        if (radius <= 0 ) 
            localitySB.setValue(0);
        else if (radius <= 5) //and > 0
            localitySB.setValue(radius);
        else // radius > 5
            localitySB.setValue(6);        
    }
*/
 
    private class localityAdjustmentListener implements AdjustmentListener {
        public void adjustmentValueChanged(AdjustmentEvent e) {
            LayoutableNode select = tgPanel.getSelect();                        
            if (select!=null || getLocalityRadius() == LocalityUtils.INFINITE_LOCALITY_RADIUS)
               tgPanel.setLocale(select, getLocalityRadius());
           }
    }
}
